# This file may not be shared/redistributed without permission. Please read copyright notice in the git repo. If this file contains other copyright notices disregard this text.
from irlc.ex05.direct import direct_solver, get_opts
from irlc.ex05.pendulum_model_variant import DirectPendulumModel
from irlc.ex05.direct_plot import plot_solutions
import numpy as np


def compute_pendulum_solutions():
    model = DirectPendulumModel()
    """
    Test out implementation on a fairly small grid. Note this will work fairly terribly.
    """
    guess = {'t0': 0,
             'tF': 3,
             'x': [np.asarray([0, 0]), np.asarray([np.pi, 0])],
             'u': [np.asarray([0]), np.asarray([0.5])]}

    options = [get_opts(N=8, ftol=1e-3, guess=guess),
               get_opts(N=40, ftol=1e-3),
               get_opts(N=60, ftol=1e-6),
               ]

    solutions = direct_solver(model, options)
    return model, solutions

if __name__ == "__main__":
    model, solutions = compute_pendulum_solutions()
    plot_solutions(model, solutions, animate=True, pdf="direct_pendulum_real")
