# This file may not be shared/redistributed without permission. Please read copyright notice in the git repo. If this file contains other copyright notices disregard this text.
import sympy as sym
from irlc.ex03.control_model import ControlModel
from irlc.ex03.control_cost import SymbolicQRCost
from irlc.ex04.discrete_control_model import DiscreteControlModel
import gymnasium as gym
from gymnasium.spaces.box import Box
from irlc.ex04.control_environment import ControlEnvironment
import numpy as np
from irlc.ex04.model_pendulum import PendulumModel


class DirectPendulumModel(PendulumModel):
    def __init__(self,  l=1., m=.8, max_torque=4.0):
        super().__init__(l=l, m=m, max_torque=max_torque)

    def get_cost(self) -> SymbolicQRCost:
        return SymbolicQRCost(R=np.ones((1, 1)), Q=0 * np.eye(2))  

    def tF_bound(self) -> Box:  
        return Box(0.5, 3, shape=(1,), dtype=float)
